//Gpib.h
 
/********************COPYRIGHT NOTIFICATION**********************************
This software was developed under a United States Government license
described on the COPYRIGHT_UniversityOfChicago file included as part
of this distribution.
****************************************************************************/
/*
        Author: Marty Kraimer
        Original Author: Jim Kowalkowski (for Hideos)
        Date: 22JUL98
*/
 
#ifndef GpibH
#define GpibH

class WatchDog;
class DLList;

extern "C" {
#include <semLib.h>
}

enum gpibStatus {gpibSuccess,gpibTimeout,gpibFailure};

class Gpib 
{
public:
    Gpib(int card);
    static Gpib *findGpib(int card);
    // cmd returns actual number bytes transfered
    virtual int cmd(const char *buf, int cnt, int time_limit) = 0;
    // write returns actual number bytes transfered
    virtual int write(const char *buf, int cnt,
	int address, int time_limit) = 0;
    virtual gpibStatus read(char *buf, int cnt, int *actual,
	int address, int time_limit, int eos) = 0;
    gpibStatus getStatus() const {return(ioStatus);}
protected:
    void startIoTimeout(int seconds);
    void waitIo();
    void waitIo(int seconds);
    int card;
    gpibStatus ioStatus;
    SEM_ID ioComplete;
private:
    static void timoutHandler(void *pvt);
    WatchDog *pwg;
    static DLList *pCardList;
};

#endif // GpibH
