// Char8ArrayMessage.h

#ifndef Char8ArrayMessageH
#define Char8ArrayMessageH

#include "Message.h"
#include "StandardFieldsMessage.h"
class DLList;

class Char8ArrayMessage : public StandardFieldsMessage
{
public:
    Char8ArrayMessage();
    virtual ~Char8ArrayMessage() {}
    virtual void init();
    virtual int32  toBuffer(char **buffer) const;
    virtual int32  fromBuffer(const char **buffer);
    virtual int32  fromBufferSwitch(const char **buffer);
    virtual void print() const;
    static void *operator new(size_t size);
    void operator delete(void *p, size_t size);
    //Char8ArrayMessage specific methods
    void setSize(int32 size);
    int32 getSize() { return(size); }
    int32 getMaxSize() { return(maxSize); };
    void allocValue(int32 maxSize);
    void freeValue();
    //following are for use by client/server
    char8 *value;
private:
    static DLList *pFreeList;
    int32 maxSize;
    int32 size;
    // Disallow copy constructor, assignment operator 
    Char8ArrayMessage(const Char8ArrayMessage&);
    Char8ArrayMessage& operator=(const Char8ArrayMessage&);
};

inline void Char8ArrayMessage::init()
{ StandardFieldsMessage::init(); maxSize=0; size=0; value=0; }

inline Char8ArrayMessage:: Char8ArrayMessage()
: StandardFieldsMessage(messageTypeChar8Array)
{ init(); }

#endif /*Char8ArrayMessageH*/
