// ConnectMessage.cc

extern "C" {
#include <stdlib.h>
#include <stddef.h>
#include <string.h>
#include <stdio.h>
}

#include "Message.h"
#define ConnectMessageDEFINE
#include "ConnectMessage.h"
#undef ConnectMessageDEFINE

DLList* ConnectMessage::pFreeList = 0;

void ConnectMessage::init() { status=connectNo; }

int32 ConnectMessage:: toBuffer(char **buffer) const
{
    int16 ival;
    int32 nbytes;

    nbytes = Message::toBuffer(buffer);
    ival = (int16)status;
    nbytes += MPF::toBuffer(buffer,ival);
    return(nbytes);
}

int32 ConnectMessage:: fromBuffer(const char **buffer)
{
    int16 ival;
    int32 nbytes=0;

    nbytes = Message::fromBuffer(buffer);
    nbytes += MPF::fromBuffer(buffer,&ival);
    status = (connectStatus)ival;
    return(nbytes);
}

int32 ConnectMessage:: fromBufferSwitch(const char **buffer)
{
    int16 ival;
    int32 nbytes=0;

    nbytes = Message::fromBufferSwitch(buffer);
    nbytes += MPF::fromBufferSwitch(buffer,&ival);
    status = (connectStatus)ival;
    return(nbytes);
}

void ConnectMessage:: print() const
{
    Message::print();
    printf("status %d %s\n",status,connectStatusString[status]);
}

void *ConnectMessage:: operator new(size_t size)
{return MPF:: allocate(&pFreeList,size);}

void ConnectMessage:: operator delete(void *p, size_t size)
{MPF::free(pFreeList,p,size);}
