// ConnectMessage.h

#ifndef ConnectMessageH
#define ConnectMessageH

class Message;
class DLList;

enum connectStatus
{
    connectNo,connectYes,connectNoRouter,
    connectNoServer,connectQueueFull
};

extern "C" const char *connectStatusString[];
#ifdef ConnectMessageDEFINE
const char *connectStatusString[] = 
{
    "connectNo","connectYes","connectNoRouter",
    "connectNoServer","connectQueueFull"
};
#endif

class ConnectMessage : public Message
{
public:
    ConnectMessage();
    virtual ~ConnectMessage() {};
    virtual void init();
    virtual int32  toBuffer(char **buffer) const;
    virtual int32  fromBuffer(const char **buffer);
    virtual int32  fromBufferSwitch(const char **buffer);
    virtual void print() const;
    connectStatus status;
    static void *operator new(size_t size);
    void operator delete(void *p, size_t size);
private:
    static DLList *pFreeList;
    // Disallow copy constructor, assignment operator 
    ConnectMessage(const ConnectMessage&);
    ConnectMessage& operator=(const ConnectMessage&);

};

inline ConnectMessage:: ConnectMessage()
 : Message(messageTypeConnect), status(connectNo)
{ init(); }

#endif /*ConnectMessageH*/
