// StandardFieldsMessage.cc

extern "C" {
#include <stdlib.h>
#include <stddef.h>
#include <string.h>
#include <stdio.h>
}

#include "Message.h"
#include "StandardFieldsMessage.h"

void StandardFieldsMessage::init() {
timeout=0; cmd=0; status=0; address=0; extra=0;
}

int32 StandardFieldsMessage:: toBuffer(char **buffer) const
{
    int32 nbytes;

    nbytes = Message::toBuffer(buffer);
    nbytes += MPF::toBuffer(buffer,timeout);
    nbytes += MPF::toBuffer(buffer,cmd);
    nbytes += MPF::toBuffer(buffer,status);
    nbytes += MPF::toBuffer(buffer,address);
    nbytes += MPF::toBuffer(buffer,extra);
    return(nbytes);
}

int32 StandardFieldsMessage:: fromBuffer(const char **buffer)
{
    int32 nbytes=0;

    nbytes = Message::fromBuffer(buffer);
    nbytes += MPF::fromBuffer(buffer,&timeout);
    nbytes += MPF::fromBuffer(buffer,&cmd);
    nbytes += MPF::fromBuffer(buffer,&status);
    nbytes += MPF::fromBuffer(buffer,&address);
    nbytes += MPF::fromBuffer(buffer,&extra);
    return(nbytes);
}

int32 StandardFieldsMessage:: fromBufferSwitch(const char **buffer)
{
    int32 nbytes=0;

    nbytes = Message::fromBufferSwitch(buffer);
    nbytes += MPF::fromBufferSwitch(buffer,&timeout);
    nbytes += MPF::fromBufferSwitch(buffer,&cmd);
    nbytes += MPF::fromBufferSwitch(buffer,&status);
    nbytes += MPF::fromBufferSwitch(buffer,&address);
    nbytes += MPF::fromBufferSwitch(buffer,&extra);
    return(nbytes);
}

void StandardFieldsMessage:: print() const
{
    Message::print();
    printf("  timeout %u\n",timeout);
    printf("      cmd %u\n",cmd);
    printf("   status %d\n",status);
    printf("  address %d\n",address);
    printf("    extra %d\n",cmd);
}
