// messageType.cc

extern "C" {
#include <stddef.h>
#include <string.h>
#include <stdlib.h>
#include <stddef.h>
#include <stdio.h>
}

#include "Message.h"
//Each message type must be included
//also a case must be added for each message type
#include "ConnectMessage.h"
#include "Int32Message.h"
#include "Char8ArrayMessage.h"
#include "SerialConfigMessage.h"

Message *Message::allocate(messageType type)
{
    switch(type) {
    case messageTypeConnect: return(new ConnectMessage());
    case messageTypeInt32: return(new Int32Message());
    case messageTypeChar8Array: return(new Char8ArrayMessage());
    case messageTypeSerialConfig: return(new SerialConfigMessage());
    default:
	printf("Message::allocate illegal type %d\n",(int)type);
    }
    return(0);
}
