//serverInt32.cc
#include <stdlib.h>
#include <stddef.h>
#include <string.h>
#include <stdio.h>

#include "Message.h"
#include "Int32Message.h"

struct privateData {
    int32    value;
};

int serverInt32Debug=0;


int serverInt32(char *name,int queueSize)
{
    MessageServer *pMessageServer = new MessageServer(name,queueSize);
    privateData   *pprivateData = new privateData;
    pprivateData->value = 0;
    bool allocNew = false;
    while(TRUE) {
	pMessageServer->waitForMessage();
	Message *message;
	while((message = pMessageServer->receive())) {
	    if(message->getType()!=messageTypeInt32) {
	        printf("serverInt32 got illegal message type %d\n",
		    message->getType());
	    } else {
		Int32Message  *preceive = (Int32Message *)message;
		Int32Message *psend;
		pprivateData->value = preceive->value;
		if(allocNew) {
		    psend = (Int32Message *)pMessageServer->
			allocReplyMessage(preceive,messageTypeInt32);
		    delete preceive;
		    allocNew = false;
		    psend->value = pprivateData->value;
		} else {
	            psend = preceive;
		    allocNew = true;
		}
		if(serverInt32Debug) {
		    char buffer[100];

		    sprintf(buffer,"server value %d psend %p\n",
			    pprivateData->value,psend);
		    printf("%s",buffer);
		}
	        pMessageServer->reply(psend);
	    }
	}
    }
    return(0);
}
